const CPTOver = {

	ptPrefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService)
										 .getBranch("extensions.copyplaintext.").QueryInterface(Components.interfaces.nsIPrefBranch2),

	copyplaintext: function(){
		try{
			var string = CPTOver.copyplaintext_getSelection() + "";
			if(CPTOver.ptPrefs.getBoolPref("trim"))
				string = string.replace(/^\s*|\s*$/g, "");
			if(CPTOver.ptPrefs.getBoolPref("reduceLine"))
				string = string.replace(/[\n\r]+/g, "\n");
			if(CPTOver.ptPrefs.getBoolPref("reduceSpace"))
				string = string.replace(/[ \t]+/g, " ");
			if(string != null && string.length > 0){
				var oClipBoard = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
					oClipBoard.copyString(string);
			}
		}
		 catch(err) { 
								var strings = document.getElementById("copyplainStrings");
								Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
													.getService(Components.interfaces.nsIPromptService).confirm(null,"Copy Plain Text",strings.getString("unknownErrorOccur") + "\n" + err);
		}
	},

	copyplaintext_init: function(){
		var ptContext = document.getElementById('contentAreaContextMenu');
		if(ptContext){ptContext.setAttribute("popupshowing", CPTOver.copyplaintext_showContextMenu());}
		ptContext = document.getElementById('msgComposeContext') || document.getElementById('mailContext');
		if(ptContext){ptContext.setAttribute("popupshowing", CPTOver.copyplaintext_showContextMenu());}
		var ptEdit = document.getElementById('menu_EditPopup');
		if(ptEdit){ptEdit.setAttribute("popupshowing", CPTOver.copyplaintext_showEditMenu());}
		CPTOver.copyplaintext_init2()
	},

	copyplaintext_init2: function(){
		document.getElementById("copyplaintext-context-menu").hidden=(CPTOver.copyplaintext_showMenu()==false);
		document.getElementById("copyplaintext-edit-menu").hidden=(CPTOver.copyplaintext_showEditMenu()==false);
		if(CPTOver.ptPrefs.getBoolPref("default")==true){
			document.getElementById("key_copyPlainText").setAttribute("disabled", true);
			// Remove copy plain text menu items
			document.getElementById("copyplaintext-context-menu").setAttribute("collapsed", true);
			document.getElementById("copyplaintext-edit-menu").setAttribute("collapsed",true);
			// Hijack menus
			document.getElementById("cmd_copy").addEventListener("command", CPTOver.copyplaintext, false);
			document.getElementById("key_copy").setAttribute("oncommand", "CPTOver.copyplaintext()");
			//document.getElementById("key_copy").addEventListener("command", CPTOver.copyplaintext, false);
		}
		else{
			document.getElementById("key_copyPlainText").setAttribute("disabled", false);
			// Display copy plain text menu items
			document.getElementById("copyplaintext-context-menu").setAttribute("collapsed",false);
			document.getElementById("copyplaintext-edit-menu").setAttribute("collapsed",false);
			// Hijack menus
			document.getElementById("cmd_copy").addEventListener("command", function() {goDoCommand('cmd_copy');}, false);
			document.getElementById("key_copy").addEventListener("command", function() {goDoCommand('cmd_copy');}, false);
		}
		if(CPTOver.ptPrefs.getBoolPref("trim")==false&&CPTOver.ptPrefs.getBoolPref("reduceLine")==false&&CPTOver.ptPrefs.getBoolPref("reduceSpace")==false)
		{
				document.getElementById("key_copyPlainText").setAttribute("disabled", true);
				document.getElementById("copyplaintext-context-menu").setAttribute("disabled", true);
				document.getElementById("copyplaintext-edit-menu").setAttribute("disabled", true);
		}
		else{
				document.getElementById("copyplaintext-context-menu").setAttribute("disabled", false);
		}
	},

	copyplaintext_showMenu: function(){
		try {
			var string = CPTOver.copyplaintext_getSelection();
			if(string != null && string.length > 0) {
				return true;
			}
		}catch(err) { }
		return false;
	},

	copyplaintext_getSelection: function() {
		var focusedWindow = document.commandDispatcher.focusedWindow;
		var searchStr = focusedWindow.getSelection.call(focusedWindow);
		searchStr = searchStr.toString();
		return searchStr;
	},

	copyplaintext_showEditMenu: function(){
		if(document.getElementById('copyplaintext-edit-menu') != null)
			document.getElementById('copyplaintext-edit-menu').setAttribute("disabled", !CPTOver.copyplaintext_showMenu());
	},

	copyplaintext_showContextMenu: function(){
		if(document.getElementById('copyplaintext-context-menu') != null){
			document.getElementById('copyplaintext-context-menu').setAttribute("collapsed", !CPTOver.copyplaintext_showMenu());
		}
	},

	showOptions: function() {
			var features = 'chrome,titlebar,toolbar,centerscreen,resizable,';
			window.openDialog('chrome://copyplaintext/content/options.xul', 'Copy Plain Text options', features);
	}
};

window.addEventListener("load", CPTOver.copyplaintext_init, true);
window.addEventListener("popupshowing", CPTOver.copyplaintext_init2, true);